Subject: Re: [bug#39258] Faster guix search using an sqlite cache

From: zimoun <[email-masked]>
Date: Tue, 11 Feb 2020 21:20:37 +0100

Hi Arun,

On Tue, 11 Feb 2020 at 20:07, Arun Isaac <[email-masked]> wrote:

> > Arun started the discussion on guix-devel with the idea of an inverted
> > index, and I thought this would become a second index (possibly
> > implemented using SQLite).  Perhaps I misunderstood the discussion all
> > along though, let me know!  :-)
>
> No, you didn't misunderstand. That's where it began. But, while
> implementing it, I thought I might as well replace the existing cache.

An inverted index backed by Guile as you did on guix-devel or backed
by SQLite seems a good improvement for "guix search".

> Also, I've started working on guile-xapian bindings. With that, it seems
> simpler to keep the current package cache and add a xapian index only to
> speed up package search.

Xapian would be cool!
And an SQLite based index seems easier to index locally the packages
and their history. The Guix Data Service is already doing such thing
but AFAIK using PostgreSQL and some magic. :-)

http://data.guix.gnu.org/repository/1/branch/master/package/git

All the best,
simon